# MAIN IMPORTS ================================================================================================================================================ #
import psyco
psyco.full()
import es
import os
import popuplib
# ============================================================================================================================================================= #

# * SAM IMPORTS
func   = es.import_addon('sam/functions')
admins = es.import_addon('sam/base/manager')
base   = es.import_addon('sam/base')

# '''''''''''''''''''' # Addon/Mod Info # '''''''''''''''''' #
addon = es.AddonInfo()
addon.name     = 'Admin Sounds'
addon.basename = 'asounds'
addon.status   = 0
addon.version  = '1.0.pub'
# '''''''''''''''''''''''''''''''''''''''''''''''''''''''''' #

# * VARIABLES
astag = 'ADMIN SOUNDS'
func.mpAddon(2, addon.basename)

# ============================================================================================================================================================= #
# ========================================================================== LOAD ============================================================================= #
# ============================================================================================================================================================= #
def load():
	### Addon State ###
	es.set('sam_' + addon.basename, 1)

# ============================================================================================================================================================= #
# ========================================================================= UNLOAD ============================================================================ #
# ============================================================================================================================================================= #
def unload():
	### Addon State ###
	es.set('sam_' + addon.basename, 0)

	### Popups ###
	func.popupDelete('play_sounds')

# ============================================================================================================================================================= #
# ======================================================================= MAIN BLOCKS ========================================================================= #
# ============================================================================================================================================================= #
def addonPopup(userid):
	if admins.checkAccess(es.getplayersteamid(userid), 'Play Sounds'):
		sounds = getSounds()
		if len(list(sounds)) > 0:
			func.popupDelete('play_sounds')
			popup = popuplib.easymenu('play_sounds', None , playsound)
			popup.c_beginsep = func.pline
			popup.c_pagesep  = func.pline
			popup.settitle('%s | SAM %s\n \n :: %s' % (func.menutitle, es.ServerVar(func.version), func.lang_addon(addon.basename,'playsounds_desc')))
			for item in sounds: popup.addoption(sounds[item], item)
			popup.submenu(10, 'mainPage')
			popup.send(userid)
		else:
			func.hudhint2(userid, 'ADMIN SOUNDS |:: %s' % func.lang_addon(addon.basename, 'no_sounds_listed'))
			base.displayMenu(userid)
	else: base.displayMenu(userid)

# :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: #
def playsound(userid, sound, popup):
	func.playall(sound)
	addonPopup(userid)

# ============================================================================================================================================================= #
# ======================================================================== FUNCTIONS ========================================================================== #
# ============================================================================================================================================================= #
def getSounds():
	sounds = {}
	for path, dirs, files in os.walk(func.dir_sounds):
		for sound in files:
			if sound.endswith('.mp3') or sound.endswith('.wav'):
				sounds[sound.replace('.mp3','').replace('.wav','')] = path.replace('cstrike/sound/','') + '/' + sound
	return sounds

# ============================================================================================================================================================= #
